#
# spec file for package perl-MooseX-ConfigFromFile
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-MooseX-ConfigFromFile
Version:        0.14
Release:        1.39
%define cpan_name MooseX-ConfigFromFile
Summary:        An abstract Moose role for setting attributes from a configfile
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/MooseX-ConfigFromFile/
Source0:        http://www.cpan.org/authors/id/E/ET/ETHER/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Module::Build::Tiny) >= 0.007
BuildRequires:  perl(Moose)
BuildRequires:  perl(Moose::Role)
BuildRequires:  perl(MooseX::Types::Moose)
BuildRequires:  perl(MooseX::Types::Path::Tiny) >= 0.005
BuildRequires:  perl(Test::Deep)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Requires)
BuildRequires:  perl(Test::Without::Module)
BuildRequires:  perl(namespace::autoclean)
Requires:       perl(Moose::Role)
Requires:       perl(MooseX::Types::Moose)
Requires:       perl(MooseX::Types::Path::Tiny) >= 0.005
Requires:       perl(namespace::autoclean)
%{perl_requires}

%description
This is an abstract role which provides an alternate constructor for
creating objects using parameters passed in from a configuration file. The
actual implementation of reading the configuration file is left to concrete
sub-roles.

It declares an attribute 'configfile' and a class method 'new_with_config',
and requires that concrete roles derived from it implement the class method
'get_config_from_file'.

Attributes specified directly as arguments to 'new_with_config' supersede
those in the configfile.

the MooseX::Getopt manpage knows about this abstract role, and will use it
if available to load attributes from the file specified by the command line
flag '--configfile' during its normal 'new_with_options'.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Build.PL --installdirs=vendor
./Build build --flags=%{?_smp_mflags}

%check
./Build test

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes CONTRIBUTING LICENSE README

%changelog
* Wed Aug 19 2015 coolo@suse.com
- updated to 0.14
  see /usr/share/doc/packages/perl-MooseX-ConfigFromFile/Changes
  0.14      2015-08-16 03:11:52Z
  - update some distribution tooling
* Mon Dec  9 2013 coolo@suse.com
- updated to 0.13
  - re-release to fix compile test
* Fri Oct  4 2013 coolo@suse.com
- updated to 0.12
  - warnings tests bypassed during installation
  - repository migrated from shadowcat to the github moose organization
* Thu Aug  1 2013 coolo@suse.com
- updated to 0.11
  - bump prereq version for MooseX::Types::Path::Tiny to ensure a
    broken version is not installed
  0.10      2013-02-12 13:17:44 PST-0800 (Karen Etheridge)
  - allow clean composition into a role, without requiring an -exclude
  0.09      2013-02-11 09:35:50 PST-0800 (Karen Etheridge)
  - removed prereqs which are only used for optional tests
  0.08      2013-02-09 16:24:27 PST-0800 (Karen Etheridge)
  - allow configfiles called "0"
  - configfile value now passed through to new()
  - new _get_default_configfile method added, which consumers can
    override to provide a default value without having to redefine the
    attribute itself (via RT#79746) -- PLEASE READ THE DOCUMENTATION
    if you override the configfile attribute!
  0.07      2013-02-04 (Karen Etheridge)
  - fixed tests to not load optional dependencies
  0.06      2013-02-03 (Karen Etheridge)
  - the configfile attribute is now a Path::Tiny, not a Path::Class
    (coercions from strings are still supported, and now also from any
    other type that has a string coercion).
  0.05      2013-02-03 (Karen Etheridge)
  - documentation corrected to demostrate how to properly override the
    configfile method to provide a default from the consuming class,
    without having to redefine the attribute itself
  - if MooseX::Getopt is installed, the configfile attribute has the
    Getopt trait applied
  0.04      2011-12-17
  - Call the configfile attribute default sub if it is a sub, not just
    a string, just like MooseX::Getopt does (RT#73325, Karen Etheridge)
* Sun Dec 25 2011 coolo@suse.com
- update to 0.03
  - The test suite now uses Test::Fatal instead of Test::Exception (Karen
    Etheridge).
  - Fix bug reported by Strayph in #moose with inheritance RT#63624 (perigrin)
  - Add repository metadata
  - Fix RT#57023, RT#49369.
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Wed Oct 13 2010 coolo@novell.com
- buildignore require of -Types-Path-Class to avoid build cycle
* Mon Jun 14 2010 pascal.bleser@opensuse.org
- initial package (0.02)
